#----------------------------------------------------------------
# Miscellanous Configuration
#----------------------------------------------------------------

# Period in miliseconds for checking scanning progress
set s(loopperiod)	1000

# Preview and Scan mode
set c(prefile)			preview
set s(preresolutionRange)       {15 40 1}
set s(premode)                  Gray
set s(preresolution)            27
set s(Defaultmode)		Color
set s(Defaultresolution)	150

# Quick mode description: unspecified options are set to Default.
set c(mode_quick_set) {
    { Copy     { mode=Gray    resolution=150 } }
    { Fax      { mode=Lineart resolution=200 } } 
    { OCR      { mode=Lineart resolution=300 } }
    { Default  {} }
}

# Paper quick settings, length in inch.
set c(size_quick_set) {
    { Max     { 0.0  0.0    $s(scanwidth) $s(scanheight) } }
    { A4      { 0.0  0.0    8.268  11.6  } }
    { Letter  { 0.0  0.0    8.5    11.0  } }
    { Photo   { 0.0  0.0    5.906  3.937 } }
}

# Length units, their display formats and conversion factors
set s(unitList) {
    { mm    25.5  %0.0f }
    { cm    2.54  %0.1f }
    { inch   1.0  %0.2f }
    { pt    72.0  %0.0f }
}

# Define variables for later use
foreach i $s(optionList) {
    set variable [lindex $i 2]
    set default  [lindex $i 4]
    set s(Default$variable) $default
    set s(pre$variable) $default
}
foreach i $s(modeList) { set modename [lindex $i 0]
    set s([set modename]format) [lindex $i 1]
    set s([set modename]dsizefactor) [lindex $i 2]
    set s([set modename]option) [lindex $i 3]
}
foreach i $s(unitList) { set unitname [lindex $i 0]
    set s(c$unitname) [lindex $i 1]
    set s(f$unitname) [lindex $i 2]
}
foreach i $c(mode_quick_set) { set c(qmode[lindex $i 0]) [lindex $i 1] }
foreach i $c(size_quick_set) { set c(qpaper[lindex $i 0]) [lindex $i 1] }

# Adopted scanning mode options in this program
set s(settingList) "mode resolution"
foreach i $s(optionList) {lappend s(settingList) [lindex $i 2]}
foreach i $s(settingList) {set s($i) $s(Default$i)}

# Fonts
# entry font
set l(f1) -adobe-helvetica-bold-r-*--12-120-*-*-*-*-*-*
# fixed font
set l(f2) -bitstream-courier-bold-r-*--14-140-*-*-*-*-*-*

# Color
# entry color
set l(c1) blue
# primary rectangle
set l(c2) blue
# registed rectangle
set l(c3) red
# currently processed rectangle
set l(c5) blue
# scanning progress bar
set l(c6) blue

#----------------------------------------------------------------
# User Configuration
#----------------------------------------------------------------

# The directory where the configuration file and temporary files are kept
set c(tkscandir) $env(HOME)/.tkscan
if [file exists $c(tkscandir)] {
    if [file isdirectory $c(tkscandir)] {
    } else {
        puts "tkscan: ~/.tkscan exists but not a directory"
        exit
    }
} else {
    puts "tkscan: No $c(tkscandir) directory, create it."
    exec mkdir $c(tkscandir)
}
set c(scanout)		""
set c(userconf)		"$c(tkscandir)/init"
set c(tmpdirclear)	1

# The following entries are saved in the user configuration file.
set s(saveList) "device preresolutionRange premode preresolution pregamma unit"
foreach i $s(settingList) {append s(saveList) " Default$i"}
set c(saveList) "mode_quick_set size_quick_set tmpdirclear"

